package com.cours.examples;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import com.cours.annotations.MyAnnotation;

/**
 *
 * @author Administrateur
 */
public class Vehicule {

	// attributs
	private static final Log log = LogFactory.getLog(Vehicule.class);

	@MyAnnotation
	protected String marque;
	@MyAnnotation
	protected String couleur;
	@MyAnnotation
	protected int annee;
	@MyAnnotation
	protected double taille;
	@MyAnnotation
	protected boolean estAssure;

	// constructeurs
	public Vehicule() {
		log.debug("Contructeur Vehicule sans argument");
	}

	public Vehicule(String marque, String couleur) {
		this.marque = marque;
		this.couleur = couleur;
		log.debug("Contructeur Vehicule(string,string)");
	}

	public Vehicule(String marque, String couleur, int annee, double taille, boolean estAssure) {
		this.marque = marque;
		this.couleur = couleur;
		this.annee = annee;
		this.taille = taille;
		this.estAssure = estAssure;
		log.debug("Contructeur Vehicule(string,string,int,double,bool)");
	}
	// methode descriptionVehicule

	public void descriptionVehicule() {
		log.debug("Votre vehicule peut être décrit de la façon suivante : " + this.toString());
	}
	// Les accesseurs
	public String getMarque() {
		return marque;
	}

	public String getCouleur() {
		return couleur;
	}

	public int getAnnee() {
		return annee;
	}

	public double getTaille() {
		return taille;
	}

	public boolean getEstAssure() {
		return estAssure;
	}
	// les modificateurs

	public void setMarque(String marque) {
		this.marque = marque;
	}

	public void setCouleur(String couleur) {
		this.couleur = couleur;
	}

	public void setAnnee(int annee) {
		this.annee = annee;
	}

	public void setTaille(double taille) {
		this.taille = taille;
	}

	public void setEstAssure(boolean estAssure) {
		this.estAssure = estAssure;
	}

	public static String getMarqueCouleur(String marque, String couleur) {
		String marqueCouleur = "Votre Vehicule : [marque=" + marque + " , couleur=" + couleur + "]";
		log.debug("marqueCouleur : " + marqueCouleur);
		return marqueCouleur;
	}

	@Override
	public String toString() {
		return String.format("[marque=%s,couleur=%s,annee=%s,taille=%s,estAssure=%s]", marque, couleur, annee, taille,
				estAssure);
	}
}
